%define branch 0
%{?_branch: %{expand: %%global branch 1}}
%define revision 830350

%define unstable 1
%{?_unstable: %{expand: %%global unstable 1}}

%define with_java 1
%{?_with_java: %{expand: %%global with_java 1}}

%if %{unstable}
%define dont_strip 1
%endif

%if %{with_java}
# Do not require java stuff just because we have a java backend
%define _requires_exceptions libjvm\.so
%endif

Name: soprano
Summary: Library which provides a nice QT interface to RDF
Version: 2.1.1
%if %branch
Release: %mkrel 0.%{revision}.3
%else
Release: %mkrel 3
%endif
Epoch: 4
Group: System/Libraries
License: LGPLv2+
URL: http://soprano.sourceforge.net
%if %branch
Source: soprano-%version.%{revision}.tar.bz2
%else
Source: soprano-%version.tar.bz2
%endif
Patch0:        soprano-2.1.1-trunk.diff
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: cmake >= 2.4.5
BuildRequires: redland-devel
BuildRequires: qt4-devel >= 4.4.0
BuildRequires: clucene-devel
BuildRequires: kde4-macros
%if %with_java
BuildRequires: java-rpmbuild
BuildRequires: chrpath
%endif
BuildRequires: doxygen

%description
Soprano (formally known as QRDF) is a library which provides a nice QT
interface to RDF storage solutions.  It has a modular structure which allows to
replace the actual RDF storage implementation used.  Currently two
implementations are working.  The first and most important backend used in
Soprano is based on librdf, the Redland RDF Application Framework.  The second
backend is the more interesting one as it uses the NEPOMUK-KDE backbone library
to connect to a NEPOMUK RDF triple service, thus providing a nice interface for
applications not aware of Nepomuk services.

%files
%defattr(-,root,root)
%_bindir/sopranocmd
%_bindir/sopranod
%_bindir/onto2vocabularyclass
%dir %_datadir/soprano/
%_datadir/soprano/*

#---------------------------------------------------------------------------------

%define libsopranomajor 4
%define libsoprano %mklibname soprano %libsopranomajor

%package -n %libsoprano
Summary:    Library for %name
Group:      Development/C
Requires:   %name
Obsoletes: %{_lib}soprano3 < 4:1.97.0-0.725573.5

%description -n %libsoprano
Soprano (formally known as QRDF) is a library which provides a nice QT
interface to RDF storage solutions.  It has a modular structure which allows to
replace the actual RDF storage implementation used.  Currently two
implementations are working.  The first and most important backend used in
Soprano is based on librdf, the Redland RDF Application Framework.  The second
backend is the more interesting one as it uses the NEPOMUK-KDE backbone library
to connect to a NEPOMUK RDF triple service, thus providing a nice interface for
applications not aware of Nepomuk services.

%if %mdkversion < 200900
%post -n %libsoprano -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -n %libsoprano -p /sbin/ldconfig
%endif

%files -n %libsoprano
%defattr(-,root,root)
%_libdir/libsoprano.so.%{libsopranomajor}*
%dir %_libdir/soprano
%_libdir/soprano/*

#---------------------------------------------------------------------------------

%define libsopranoclient %mklibname sopranoclient 1

%package -n %libsopranoclient
Summary: Library for %name
Group: Development/C
Requires: %name
Obsoletes: %{_lib}soprano3 < 4:1.97.0-0.725573.5

%description -n %libsopranoclient
Soprano (formally known as QRDF) is a library which provides a nice QT
interface to RDF storage solutions.  It has a modular structure which allows to
replace the actual RDF storage implementation used.  Currently two
implementations are working.  The first and most important backend used in
Soprano is based on librdf, the Redland RDF Application Framework.  The second
backend is the more interesting one as it uses the NEPOMUK-KDE backbone library
to connect to a NEPOMUK RDF triple service, thus providing a nice interface for
applications not aware of Nepomuk services.

%if %mdkversion < 200900
%post -n %libsopranoclient -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -n %libsopranoclient -p /sbin/ldconfig
%endif

%files -n %libsopranoclient
%defattr(-,root,root)
%_libdir/libsopranoclient.so.*

#---------------------------------------------------------------------------------

%define libsopranoserver %mklibname sopranoserver 1

%package -n %libsopranoserver
Summary: Library for %name
Group: Development/C
Requires: %name
Obsoletes: %{_lib}soprano3 < 4:1.97.0-0.725573.5

%description -n %libsopranoserver
Soprano (formally known as QRDF) is a library which provides a nice QT
interface to RDF storage solutions.  It has a modular structure which allows to
replace the actual RDF storage implementation used.  Currently two
implementations are working.  The first and most important backend used in
Soprano is based on librdf, the Redland RDF Application Framework.  The second
backend is the more interesting one as it uses the NEPOMUK-KDE backbone library
to connect to a NEPOMUK RDF triple service, thus providing a nice interface for
applications not aware of Nepomuk services.

%if %mdkversion < 200900
%post -n %libsopranoserver -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -n %libsopranoserver -p /sbin/ldconfig
%endif

%files -n %libsopranoserver
%defattr(-,root,root)
%_libdir/libsopranoserver.so.*

#---------------------------------------------------------------------------------

%define libsopranoindex %mklibname sopranoindex 1

%package -n %libsopranoindex
Summary: Library for %name
Group: Development/C
Requires: %name
Obsoletes: %{_lib}soprano3 < 4:1.97.0-0.725573.5

%description -n %libsopranoindex
Soprano (formally known as QRDF) is a library which provides a nice QT
interface to RDF storage solutions.  It has a modular structure which allows to
replace the actual RDF storage implementation used.  Currently two
implementations are working.  The first and most important backend used in
Soprano is based on librdf, the Redland RDF Application Framework.  The second
backend is the more interesting one as it uses the NEPOMUK-KDE backbone library
to connect to a NEPOMUK RDF triple service, thus providing a nice interface for
applications not aware of Nepomuk services.

%if %mdkversion < 200900
%post -n %libsopranoindex -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -n %libsopranoindex -p /sbin/ldconfig
%endif

%files -n %libsopranoindex
%defattr(-,root,root)
%_libdir/libsopranoindex.so.*

#---------------------------------------------------------------------------------

%package devel
Summary: Library
Group: Development/C
Provides: libsoprano-devel
Requires: %libsoprano = %{epoch}:%version-%release
Obsoletes: %libsoprano-devel < 3:3.0-0.714066.1
Requires: %libsoprano = %{epoch}:%version-%release
Requires: %libsopranoclient = %{epoch}:%version-%release
Requires: %libsopranoserver = %{epoch}:%version-%release
Requires: %libsopranoindex = %{epoch}:%version-%release

%description devel
This package contains the headers that programmers will need to develop
applications which will use %{name}.

%files devel
%defattr(-,root,root)
%dir %_includedir/soprano/
%_includedir/soprano/*
%dir %_includedir/Soprano/
%_includedir/Soprano/*
%_libdir/pkgconfig/soprano.pc
%_libdir/*.so
%_datadir/dbus-1/interfaces/*

#---------------------------------------------------------------------------------

%prep
%if %branch
%setup -q -n %name
%else
%setup -q -n %name-%version
%endif
%patch0 -p0

%build
%if %with_java
export JAVA_HOME=%{java_home}
%endif
%cmake_qt4
%make


%install
rm -rf %buildroot
%makeinstall_std -C build

%if %with_java
# Load libjvm.so from the JRE directory instead of SDK directory. This
# works with Sun-derived JREs, but GCJ/Jamvm etc have libjvm.so in different
# directories. Maybe there should be an alternative pointing to libjvm.so.
old_rpath=$(chrpath -l %{buildroot}%{_libdir}/soprano/libsoprano_sesame2backend.so | cut -d= -f2)
chrpath -r %{_jvmdir}${old_rpath#%{java_home}} %{buildroot}%{_libdir}/soprano/libsoprano_sesame2backend.so
%endif

%clean 
rm -rf %buildroot



%changelog
* Sun Sep 28 2008 Anssi Hannula <anssi@mandriva.org> 4:2.1.1-3mdv2009.0
+ Revision: 289000
- do not require java libs, most users do not need them
- fix java backend to look up libjvm.so in a better directory (still
  only works with Sun-derived JREs since other JREs have it in different
  directories

* Thu Aug 14 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.1.1-2mdv2009.0
+ Revision: 272135
- Update soprano to trunk ( asked by strueg)

* Thu Jul 31 2008 Funda Wang <fundawang@mandriva.org> 4:2.1.1-1mdv2009.0
+ Revision: 257848
- New version 2.1.1

* Sun Jul 27 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 4:2.1-2mdv2009.0
+ Revision: 250650
- use %%java_home macro instead of hardcoding paths to java place
- use buildrequire on java-rpmbuild instead of specific java devel packages

* Sat Jul 26 2008 Funda Wang <fundawang@mandriva.org> 4:2.1-1mdv2009.0
+ Revision: 250124
- New version 2.1 final
- fix url

* Sat Jul 26 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.0.99-0.830350.3mdv2009.0
+ Revision: 250103
- Fix use of java backend thanks to  Adrien BUSTANY

* Sun Jul 20 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.0.99-0.830350.2mdv2009.0
+ Revision: 239218
- Disable java support this is still broken

* Tue Jul 15 2008 Helio Chissini de Castro <helio@mandriva.com> 4:2.0.99-0.830350.1mdv2009.0
+ Revision: 236091
- New svn snapshot
- Soprano is qt only, so services is in datadir
- Proper java for old distros

* Mon Jul 14 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.0.99-0.804023.5mdv2009.0
+ Revision: 234535
- Add kde4-macros as BuildRequires
- Fix java detection for non 32 bit
- Fix java detection for openjdk
- Fix java detection for openjdk

  + Helio Chissini de Castro <helio@mandriva.com>
    - Proper interface dir

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon May 19 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.0.99-0.804023.3mdv2009.0
+ Revision: 209226
- Disable java build because it gave an undefined symbol: JNI_CreateJavaVM

* Mon May 05 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.0.99-0.804023.2mdv2009.0
+ Revision: 201348
- Rebuild with right path

* Sun May 04 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.0.99-0.804023.1mdv2009.0
+ Revision: 201207
- Fix tarball
- New snapshot needed by next kdelibs4
- Versionate qt4-devel BR
- Update to version 2.0.98 (needed by kdebase4-runtime 4.0.70 )

  + Helio Chissini de Castro <helio@mandriva.com>
    - Starting to push new infrastructure for devel KDE 4.1. KDE 4 will be on / now. KDE is dead. Long live KDE vi kdenetwork4/SPECS/kdenetwork4.spec ;-)

* Thu Feb 21 2008 Helio Chissini de Castro <helio@mandriva.com> 4:2.0.2-0.777761.1mdv2008.1
+ Revision: 173629
- Update for soprano 2.0.2 trunk to match nepomuk playground tool

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild
    - fix "foobar is blabla" summary (=> "blabla") so that it looks nice in rpmdrake
    - fix description-line-too-long

* Sat Jan 26 2008 Nicolas Lécureuil <neoclust@mandriva.org> 4:2.0.0-0.758303.3mdv2008.1
+ Revision: 158162
- Fix File list
- Build with java enable as it build now

* Mon Jan 07 2008 Helio Chissini de Castro <helio@mandriva.com> 4:2.0.0-0.758303.2mdv2008.1
+ Revision: 146283
- Proper split
- Update for 2.0.0 from svn
- Removed another useless patch

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Mon Dec 10 2007 Nicolas Lécureuil <neoclust@mandriva.org> 4:1.99.0-0.746844.7mdv2008.1
+ Revision: 116999
- New release 1.99.0
  Add a switch for java support, do not activate it for the moment ( do not build )

* Wed Nov 07 2007 Nicolas Lécureuil <neoclust@mandriva.org> 4:1.97.1-0.733572.7mdv2008.1
+ Revision: 106780
- Fix version in version.h

* Wed Nov 07 2007 Nicolas Lécureuil <neoclust@mandriva.org> 4:1.97.1-0.733572.6mdv2008.1
+ Revision: 106638
- New snapshot needed for the upcoming rpms of KDE4

* Thu Oct 25 2007 Nicolas Lécureuil <neoclust@mandriva.org> 4:1.97.0-0.725573.6mdv2008.1
+ Revision: 102219
- Fix conflict

  + Thierry Vignaud <tvignaud@mandriva.com>
    - revert conflicts, better use rpmlint to kill the bogus package thus enabling
      smoother upgrade with yet not updated third party lib users

  + Funda Wang <fundawang@mandriva.org>
    - use icedtea provided alternative symbolink

* Wed Oct 17 2007 Funda Wang <fundawang@mandriva.org> 4:1.97.0-0.725573.5mdv2008.1
+ Revision: 99480
- add icedtea dir macro for x86_64 building
- add conflict on incorrectly named package to ease upgrading

  + Nicolas Lécureuil <neoclust@mandriva.org>
    - Add doxygen as buildrequire
    - Say hello to sesame backend

* Tue Oct 16 2007 Nicolas Lécureuil <neoclust@mandriva.org> 4:1.97.0-0.725573.4mdv2008.1
+ Revision: 99219
- Do not activate sesam for the moment
- Fix BuildRequires
- New snapshot
  Fix file list

* Mon Oct 15 2007 Funda Wang <fundawang@mandriva.org> 4:1.97.0-0.724490.2mdv2008.1
+ Revision: 98710
- new major of libsoprano

* Sun Oct 14 2007 Nicolas Lécureuil <neoclust@mandriva.org> 4:1.97.0-0.724490.1mdv2008.1
+ Revision: 98344
- New svn snapshot
  Use real release number

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix summary-ended-with-dot

* Thu Sep 27 2007 Tiago Salem <salem@mandriva.com.br> 3:3.0-0.714066.3mdv2008.0
+ Revision: 93396
- Bumping release and fixing Obsoletes tag

* Wed Sep 19 2007 Tiago Salem <salem@mandriva.com.br> 3:3.0-0.714066.2mdv2008.0
+ Revision: 91171
- Making Obsoletes tags versioned

* Tue Sep 18 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 3:3.0-0.714066.1mdv2008.0
+ Revision: 89812
- Fix version making it possible to submit

  + Tiago Salem <salem@mandriva.com.br>
    - Revision update to 714066

  + Helio Chissini de Castro <helio@mandriva.com>
    - Upgrade for revision 688549

* Thu Jul 05 2007 Helio Chissini de Castro <helio@mandriva.com> 3:3.0-0.674845.1mdv2008.0
+ Revision: 48592
- Update from revision 674845

* Wed Jun 20 2007 Helio Chissini de Castro <helio@mandriva.com> 2:3.0-0.20070614.1mdv2008.0
+ Revision: 41914
- Added proper obsoletes

  + Michael Scherer <misc@mandriva.org>
    - fix url

* Thu Jun 14 2007 Helio Chissini de Castro <helio@mandriva.com> 2:3.0-0.20070614mdv2008.0
+ Revision: 39544
- Update from 20070614 svn date
- New svn update
- New package layout

* Mon May 14 2007 Nicolas Lécureuil <neoclust@mandriva.org> 2:3.0-0.20070514.1mdv2008.0
+ Revision: 26680
- New snapshot

* Wed May 02 2007 Laurent Montel <lmontel@mandriva.org> 2:3.0-0.20070502.4mdv2008.0
+ Revision: 20572
- Fix install

* Wed May 02 2007 Laurent Montel <lmontel@mandriva.org> 2:3.0-0.20070502.3mdv2008.0
+ Revision: 20471
- Remove release
- aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
- Update it

* Wed May 02 2007 Laurent Montel <lmontel@mandriva.org> 2:3.0-0.20070502.2mdv2008.0
+ Revision: 20448
- Add package version date
- New version

